angular.module('demoWidget8Module')

    /**
     * Configuration for the custom widget
     * The config contains all configurable properties of the widget
     */
    .config(['dashboardProviderProvider','columnTypeConfigUrlServiceProvider',
        function (dashboardProviderProvider, columnTypeConfigUrlServiceProvider) {
            dashboardProviderProvider.widget('demoWidget8', {
                title: 'Demo Widget 8',
                category: 'customWidget',
                toolTip : {
                    "de":"Demo Widget 8",
                    "en":"Demo Widget 8"
                },
                actions: ['assignData',
                    'filter','translate',
                    'actions',
                    'editName',
                    'hideHeader','hideBorder',
                    'autoRefresh',
                    'hLine',
                    'preselection',
                    'copy', 'paste', 'cut', 'delete',
                    'toTop', 'bringForward', 'sendBackward', 'toBack'],
                viewModeActions: ['deleteSelection'],
                description: 'Demo Widget 8 - Multi-language',
                templateUrl: 'widgets/customWidgets/demoWidget8/partials/demoWidget8.html',
                iconUrl: 'widgets/customWidgets/demoWidget8/assets/images/demoWidget8MenuIcon_32x32.png',
                controller: 'demoWidget8Ctrl',
                container: {
                    hideHeader: false,
                    hideBorder: false,
                    width: 400,
                    height: 300,
                    contentMinHeight: 60,
                    contentMinWidth: 60
                },
                assignData: 'widgets/customWidgets/demoWidget8/partials/assignDataDialog/assignData.html',
                assignColumns: 'widgets/customWidgets/demoWidget8/partials/assignDataDialog/assignColumns.html',
                advancedProperties: 'widgets/customWidgets/demoWidget8/partials/assignDataDialog/advancedProperties.html',
                resolve: {
                    widgetInterface: function(config, demoWidget8DataService) {
                        config.widgetInterface = {
                            getDataMapping: demoWidget8DataService.getDataMapping,
                            calculateCoordinateList: demoWidget8DataService.calculateCoordinateList,
                            getTranslationKeys : demoWidget8DataService.getTranslationKeys
                        };
                    }
                },
                thresholdProperties: 'widgets/customWidgets/demoWidget8/partials/assignDataDialog/thresholdProperties.html',
                actionFramework: {
                    getActionTriggers: function(widgetConfig) {
                        var supportedTriggers = [{
                            key: 'onSelectionChange',
                            name: 'On Selection Change'
                        },{
                            key: 'onMouseEnter',
                            name: 'On Mouseover'
                        },{
                            key: 'onClick',
                            name: 'On Click'
                        }];
                        return supportedTriggers;



                    }
                }
            });

            columnTypeConfigUrlServiceProvider.addColumnTypeUrlMapByWidget('demoWidget8',
                {
                    NUMERIC : ['widgets/customWidgets/demoWidget8/partials/assignDataDialog/columnTypeConfigTemplates', 'numeric.html'].join('/'),
                    DATE : ['widgets/customWidgets/demoWidget8/partials/assignDataDialog/columnTypeConfigTemplates', 'date.html'].join('/'),
                    TEXT : ['widgets/customWidgets/demoWidget8/partials/assignDataDialog/columnTypeConfigTemplates', 'text.html'].join('/')
                });
        }
    ]);